#include <bits/stdc++.h>
using namespace std;
#define IOS ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);cerr.tie(0);
#define endl "\n"
#define int long long
int n,m;
vector<int> a(75000,0),b(75000,0);
void solve(){
	cin >> n >> m;
	for(int i=0;i<n;i++)cin>>a[i];
	for(int i=0;i<m;i++)cin>>b[i];
	sort(a.begin(),a.begin()+n);
	//sort(b.begin(),b.begin()+m);
	vector<int>agap(n-1,0);
	for(int i=1;i<n;i++){
		agap[i-1]=a[i]-a[i-1];
	}
	//for(int i=1;i<m;i++)bgap[i-1]=b[i]-b[i-1];
	int resa=agap[0];
	for(int i=1;i<n-1;i++){
		resa=__gcd(resa,agap[i]);
	}
	if(resa==1)cout<<0<<endl;
	else{
		int ref=a[0];
		for(int i=0;i<m;i++){
			if(abs(b[i]-ref)%resa==0){
				cout<<0<<endl;
				return;
			}
		}
		cout<<1<<endl;
	}
}
int32_t main(){
	IOS
	int t;
	cin >> t;
	while(t--)solve();
	return 0;
}